## nnstreamer-nnstreamer.zip

=== meson_options.txt ===
# features
option('video-support', type: 'feature', value: 'enabled')
option('audio-support', type: 'feature', value: 'enabled')
option('tf-support', type: 'feature', value: 'auto')
option('tflite-support', type: 'feature', value: 'auto')
option('tflite2-support', type: 'feature', value: 'auto')
option('tflite2-custom-support', type: 'feature', value: 'disabled') # requires tflite2-support. disabled due to incompleteness.
option('pytorch-support', type: 'feature', value: 'auto')
option('caffe2-support', type: 'feature', value: 'auto')
option('deepview-rt-support', type: 'feature', value: 'auto')
option('python3-support', type: 'feature', value: 'auto')
option('mvncsdk2-support', type: 'feature', value: 'auto')
# nnfw-runtime ( details in https://review.tizen.org/gerrit/p/platform/core/ml/nnfw )
option('nnfw-runtime-support', type: 'feature', value: 'auto')
option('armnn-support', type: 'feature', value: 'auto')
option('orcc-support', type: 'feature', value: 'auto')
option('snpe-support', type: 'feature', value: 'auto')
option('qnn-support', type: 'feature', value: 'auto')
option('protobuf-support', type: 'feature', value: 'auto')
option('flatbuf-support', type: 'feature', value: 'auto')
option('tensorrt-support', type: 'feature', value: 'auto')
option('tensorrt10-support', type: 'feature', value: 'auto')
option('grpc-support', type: 'feature', value: 'auto')
option('lua-support', type: 'feature', value: 'auto')
option('mqtt-support', type: 'feature', value: 'auto')
option('tvm-support', type: 'feature', value: 'auto')
option('trix-engine-support', type: 'feature', value: 'auto')
option('nnstreamer-edge-support', type: 'feature', value: 'auto')
option('mxnet-support', type: 'feature', value: 'auto')
option('ncnn-support', type: 'feature', value: 'auto')
option('executorch-support', type: 'feature', value: 'auto')
option('executorch-llama-support', type: 'feature', value: 'auto')
option('parser-support', type: 'feature', value: 'auto') # gstreamer pipeline description <--> pbtxt pipeline
option('datarepo-support', type: 'feature', value: 'auto', description: 'Data repository sink/src for in-pipeline training') # this required json-glib-1.0.
option('ml-agent-support', type: 'feature', value: 'auto')
option('onnxruntime-support', type: 'feature', value: 'auto')
option('dali-support', type: 'feature', value: 'auto')
option('llama2c-support', type: 'feature', value: 'auto')

# booleans & other options
option('enable-test', type: 'boolean', value: true)
option('install-test', type: 'boolean', value: false)
option('enable-pytorch-use-gpu', type: 'boolean', value: false) # default value, can be specified at run time
option('enable-mediapipe', type: 'boolean', value: false)
option('enable-env-var', type: 'boolean', value: true)
option('enable-symbolic-link', type: 'boolean', value: true)
option('enable-tizen', type: 'boolean', value: false)
option('tizen-version-major', type: 'integer', min : 4, max : 9999, value: 9999) # 9999 means "not Tizen"
option('enable-element-restriction', type: 'boolean', value: false) # true to restrict gst-elements in api
option('allowed-elements', type: 'string', value: '')
option('enable-cppfilter', type: 'boolean', value: true) # Allows C++ custom filters
option('enable-filter-cpp-class', type: 'boolean', value: true) # Allows to accept C++ classes as filter subplugin implementation.
option('enable-tizen-sensor', type: 'boolean', value: false)
option('enable-edgetpu', type: 'boolean', value: false)
option('enable-openvino', type: 'boolean', value: false)
option('enable-vivante', type: 'boolean', value: false)
option('framework-priority-tflite', type: 'string', value: 'tensorflow-lite,nnfw,armnn,edgetpu', description: 'A comma separated prioritized list of neural network frameworks to open a .tflite file')
option('framework-priority-nb', type: 'string', value: '', description: 'A comma separated prioritized list of neural network frameworks to open a .nb file')
option('framework-priority-bin', type: 'string', value: '', description: 'A comma separated prioritized list of neural network frameworks to open a .bin file')
option('skip-tflite-flatbuf-check', type: 'boolean', value: false, description: 'Do not check the availability of flatbuf for tensorflow-lite build. In some systems, flatbuffers\' dependency cannot be found with meson.')
option('trix-engine-alias', type: 'string', value: 'srnpu', description: 'The alias name list of trix-engine sub-plugin. This option provides backward compatibility of the previous framework name.')
option('enable-float16', type: 'boolean', value: false, description: 'Support float16 streams with GCC extensions')

# Utilities
option('enable-nnstreamer-check', type: 'boolean', value: true)
option('enable-pbtxt-converter', type: 'boolean', value: true)

# Install Paths
option('subplugindir', type: 'string', value: '')

# Extra configuration
option('extra_config_path', type: 'string', value: '')

=== debian/changelog ===
nnstreamer (2.4.2.0) unstable bionic focal jammy sid; urgency=medium

  * 2.4.2 Release (LTS for Tizen 9.0 M2 Release)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Mon, 02 Sep 2024 11:00:00 +0900

nnstreamer (2.4.1.0) unstable bionic focal jammy sid; urgency=medium

  * 2.4.1 development starts (2.4.2-RC1)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Fri, 15 Sep 2023 18:30:00 +0900

nnstreamer (2.4.0.0) unstable xenial bionic focal; urgency=medium

  * 2.4.0 Release (LTS for Tizen 8.0 M2 Release)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 12 Sep 2023 12:50:00 +0900

nnstreamer (2.3.0.0) unstable bionic focal jammy sid; urgency=medium

  * 2.3.0 development starts as 2.4.0-RC1 for experimental and unstable features.

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 27 Sep 2022 12:06:42 +0900

nnstreamer (2.2.0.0) unstable xenial bionic focal; urgency=medium

  * 2.2.0 Release (LTS for Tizen 7.0 M2 Release)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 22 Sep 2022 17:13:32 +0900

nnstreamer (2.1.1.0) unstable xenial bionic focal; urgency=medium

  * 2.1.1 development starts for Tizen 7.0 M1 RC releases.

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 13 Apr 2022 17:20:28 +0900

nnstreamer (2.1.0.0) unstable xenial bionic focal sid; urgency=medium

  * 2.1.0 development starts (2.2.0.RC1)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 28 Sep 2021 16:50:41 +0900

nnstreamer (2.0.0.0) unstable xenial bionic focal sid; urgency=medium

  * 2.0.0 Release (LTS for Tizen 6.5 M2 release)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 28 Sep 2021 07:50:00 +0900

nnstreamer (1.7.2.1) unstable xeinal bionic focal sid; urgency=medium

  * 1.7.2 development version for Debian releases

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 07 Jul 2021 19:56:31 +0900

nnstreamer (1.7.2.0) unstable xenial bionic focal; urgency=medium

  * 1.7.2 development starts (1.8.0.RC3)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 03 Jun 2021 11:05:04 +0900

nnstreamer (1.7.1.0) unstable xenial bionic; urgency=medium

  * 1.7.1 development starts (1.8.0.RC2)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Fri, 20 Nov 2020 16:24:49 +0900

nnstreamer (1.7.0.0) unstable xenial bionic; urgency=medium

  * 1.7.0 development starts (1.8.0.RC1)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 09 Sep 2020 20:40:57 +0900

nnstreamer (1.6.0.0) unstable xenial bionic; urgency=medium

  * 1.6.0 Release (LTS for Tizen 6.0 M2 / Android-next products)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 09 Sep 2020 19:09:53 +0900

nnstreamer (1.5.3.0) unstable xenial bionic; urgency=medium

  * 1.5.3 development starts (1.6.0.RC4)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 04 Jun 2020 11:49:21 +0900

nnstreamer (1.5.2.0) unstable xenial bionic; urgency=medium

  * 1.5.2 development starts (1.6.0.RC3)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 08 Apr 2020 12:30:58 +0900

nnstreamer (1.5.1.0) unstable xenial bionic; urgency=medium

  * 1.5.1 development starts (1.6.0 RC2)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 18 Mar 2020 10:07:32 +0900

nnstreamer (1.5.0.0) unstable xenial bionic; urgency=medium

  * 1.5.0 development starts (1.6.0 RC1)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 11 Feb 2020 19:33:55 +0900

nnstreamer (1.4.0.0) unstable xenial bionic; urgency=medium

  * 1.4.0 Release (Tensor-filter API updated)

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 11 Feb 2020 19:07:14 +0900

nnstreamer (1.3.1.0) unstable xenial bionic; urgency=medium

  * 1.3.1 development starts

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Mon, 03 Feb 2020 19:37:14 +0900

nnstreamer (1.3.0.0) unstable xenial bionic; urgency=medium

  * 1.3.0 development starts

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 11 Dec 2019 13:14:00 +0900

nnstreamer (1.2.0.0) unstable xenial bionic; urgency=medium

  * 1.2.0 Release

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 11 Dec 2019 11:12:00 +0900

nnstreamer (1.0.0.0) unstable xenial bionic; urgency=medium

  * 1.0.0 Release (1.0 RC2 = 1.0 Release). NNStreamer becomes 1.0 with Tizen 5.5 M2 official release.

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 26 Sep 2019 15:39:00 +0900

nnstreamer (0.3.0.0) unstable xenial bionic; urgency=medium

  * 0.3.0 Release. 0.2.1 becomes 0.3.0 as a lot of features are included for commercialization.

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 14 Aug 2019 13:39:00 +0900

nnstreamer (0.2.1.0) unstable xenial bionic; urgency=medium

  * 0.2.1 RC Development Started

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 29 May 2019 14:52:00 -0800

nnstreamer (0.2.0.0) unstable xenial bionic; urgency=medium

  * 0.2.0 Release. 0.1.3 becomes 0.2.0 as Tizen 5.5 M1 releases with nnstreamer.

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Mon, 27 May 2019 19:08:00 +0900

nnstreamer (0.1.3.0) unstable xenial bionic; urgency=medium

  * 0.1.3 RC Development Started

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 20 Mar 2019 15:01:00 +0900

nnstreamer (0.1.2.1) unstable xenial bionic; urgency=medium

  * 0.1.2 Release

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Wed, 20 Mar 2019 15:00:00 +0900

nnstreamer (0.1.2.0) unstable xenial bionic; urgency=medium

  * 0.1.2 RC Development Started

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Tue, 26 Feb 2019 20:00:00 +0900

nnstreamer (0.1.1.1) unstable xenial bionic; urgency=medium

  * 0.1.1 Release

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Mon, 25 Feb 2019 12:00:00 +0900

nnstreamer (0.1.1.0) unstable xenial bionic; urgency=medium

  * 0.1.1 RC Development Started

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 24 Jan 2019 15:33:33 +0900

nnstreamer (0.1.0-2) unstable xenial bionic; urgency=medium

  * 0.1.0 release

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Thu, 24 Jan 2019 15:33:33 +0900

nnstreamer (0.1.0-1rc1) unstable; urgency=medium

  * Start of 0.1.0 development

 -- MyungJoo Ham <myungjoo.ham@samsung.com>  Mon, 03 Dec 2018 15:32:01 +0900



=== debian/control ===
Source: nnstreamer
Section: libs
Priority: optional
Maintainer: MyungJoo Ham <myungjoo.ham@samsung.com>
Build-Depends: gcc-9 | gcc-8 | gcc-7 | gcc-6 | gcc-5 (>=5.4),
 ninja-build, meson (>=0.49), debhelper (>=9), nnstreamer-edge-dev,
 libgstreamer1.0-dev, libgstreamer-plugins-base1.0-dev, libglib2.0-dev, libjson-glib-dev,
 gstreamer1.0-tools, gstreamer1.0-plugins-base, gstreamer1.0-plugins-good,
 libgtest-dev, ssat, libpng-dev, libopencv-dev, liborc-0.4-dev, flex, bison,
 python3, python3-dev, python3-numpy, pkg-config,
 libflatbuffers-dev, flatbuffers-compiler,
 protobuf-compiler (>=3.12), libprotobuf-dev [amd64 arm64 armhf],
 libpaho-mqtt-dev,
 tensorflow2-lite-dev,
 pytorch | libtorch-dev | gcc,
 libedgetpu1-std (>=12), libedgetpu-dev (>=12),
 openvino-dev, openvino-cpu-mkldnn [amd64],
 nnfw-dev [amd64] | gcc,
 tvm-runtime-dev, onnxruntime-dev
Standards-Version: 3.9.6
Homepage: https://github.com/nnstreamer/nnstreamer

## @todo pytorch ppa build fails in Ubuntu 24.04. revive it when pytorch gets proper ppa support.

Package: nnstreamer
Architecture: any
Multi-Arch: same
Depends: nnstreamer-core, nnstreamer-configuration, nnstreamer-single, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer plugins for Gstreamer
 Gstreamer plugins, "NNStreamer", provides access to neural network frameworks for media streams.
 This package is meta package of nnstreamer-core and nnstreamer-configuration.

Package: nnstreamer-core
Architecture: any
Multi-Arch: same
Depends: nnstreamer-edge, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer plugins for Gstreamer
 Gstreamer plugins, "NNStreamer", provides access to neural network frameworks for media streams.
 This package is core package without configuration.

Package: nnstreamer-configuration
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer plugins for Gstreamer
 Gstreamer plugins, "NNStreamer", provides access to neural network frameworks for media streams.
 This package contains nnstreamer configuration.

Package: nnstreamer-single
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Single-shot
 Element to use general neural network framework directly without gstreamer pipeline.

Package: nnstreamer-tensorflow2-lite
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer TensorFlow Lite 2.x Support
 This package allows nnstreamer to support tensorflow-lite 2.x.

Package: nnstreamer-pytorch
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, pytorch, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Pytorch Support
 This package allows nnstreamer to support pytorch.

Package: nnstreamer-caffe2
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, pytorch, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Caffe2 Support
 This package allows nnstreamer to support caffe2.

Package: nnstreamer-python3
Architecture: any
Multi-Arch: same
Depends: nnstreamer, python3, python3-numpy, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Python Custom Filter Support (3.x)
 This Package allows nnstreamer to support python custom filters

Package: nnstreamer-edgetpu
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, libedgetpu1-std, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Edge TPU support
 This package allows nnstreamer to support Edge TPU.

Package: nnstreamer-openvino
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, openvino, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer OpenVino support
 This package allows nnstreamer to support OpenVino.

Package: nnstreamer-nnfw
Architecture: amd64
Multi-Arch: same
Depends: nnstreamer-single, nnfw, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer NNFW (ONE) support
 This package allows nnstreamer to support NNFW (ONE, On-Device Neural Engine).

Package: nnstreamer-tvm
Architecture: any
Multi-Arch: same
Depends: nnstreamer, tvm-runtime, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer TVM support
 This package allows nnstreamer to support TVM

Package: nnstreamer-onnxruntime
Architecture: any
Multi-Arch: same
Depends: nnstreamer, onnxruntime, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer onnxruntime support
 This package allows nnstreamer to support onnxruntime

Package: nnstreamer-protobuf
Architecture: any
Multi-Arch: same
Depends: nnstreamer, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Protobuf converter/decoder support
 This package allows to pack/unpack tensor streams to/from protobuf.

Package: nnstreamer-flatbuf
Architecture: any
Multi-Arch: same
Depends: nnstreamer, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer Flatbuf converter/decoder support
 This package allows to pack/unpack tensor streams to/from flatbuf.

Package: nnstreamer-dev
Architecture: any
Multi-Arch: same
Depends: nnstreamer, nnstreamer-single-dev, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer development package
 Gstreamer plugins, "NNStreamer", provides access to neural network frameworks for media streams.
 This is development package for nnstreamer.

Package: nnstreamer-dev-internal
Architecture: any
Multi-Arch: same
Depends: nnstreamer-dev, nnstreamer-single-dev-internal, ${shlibs:Depends}, ${misc:Depends}
Description: Development package to access internal functions of NNStreamer.
 This may be used by API packages.
 In most cases, custom-filter or subplugin authors do not need this internal devel package; however, if they want to access more internal functions, they may need this.

Package: nnstreamer-single-dev
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single, ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer single-shot development package
 Element to use general neural network framework directly without gstreamer pipeline.

Package: nnstreamer-single-dev-internal
Architecture: any
Multi-Arch: same
Depends: nnstreamer-single-dev, ${shlibs:Depends}, ${misc:Depends}
Description: Development package to access internal functions of NNStreamer single-shot.
 This may be used by API packages.
 In most cases, custom-filter or subplugin authors do not need this internal devel package; however, if they want to access more internal functions, they may need this.

Package: nnstreamer-test-dev
Architecture: any
Multi-Arch: same
Depends: nnstreamer-dev, ${shlibs:Depends}, ${misc:Depends}
Description: Development package to provide testable environment of a subplugin (tensor_filter/custom).
 This package enables testable environment of NNStreamer sub-plugin by making nnstreamer to recognize NNSTREAMER_CONF_PATH to steer a sub-plugin path to a custom path.
 Also This package provides test templates to be used with.

Package: nnstreamer-util
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer utility
 Gstreamer plugins, "NNStreamer", provides access to neural network frameworks for media streams.
 This is a configuration checker utility for nnstreamer.

Package: nnstreamer-misc
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer extra package
 Provides additional gstreamer plugins for nnstreamer pipelines

Package: nnstreamer-datarepo
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NNStreamer MLOps Data Repository plugin packages
 NNStreamer's datareposrc/sink plugins for reading and writing files in MLOps Data Repository

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ROOT_DIR:=$(shell pwd)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export BUILDDIR=build
export NNSTREAMER_SOURCE_ROOT_PATH=$(ROOT_DIR)
export NNSTREAMER_BUILD_ROOT_PATH=${NNSTREAMER_SOURCE_ROOT_PATH}/${BUILDDIR}
export GST_PLUGIN_PATH=${NNSTREAMER_BUILD_ROOT_PATH}/gst:${NNSTREAMER_BUILD_ROOT_PATH}/ext
export NNSTREAMER_CONF=${NNSTREAMER_BUILD_ROOT_PATH}/nnstreamer-test.ini
export NNSTREAMER_FILTERS=${NNSTREAMER_BUILD_ROOT_PATH}/ext/nnstreamer/tensor_filter
export NNSTREAMER_DECODERS=${NNSTREAMER_BUILD_ROOT_PATH}/ext/nnstreamer/tensor_decoder
export NNSTREAMER_CONVERTERS=${NNSTREAMER_BUILD_ROOT_PATH}/ext/nnstreamer/tensor_converter
export NNSTREAMER_TRAINERS=${NNSTREAMER_BUILD_ROOT_PATH}/ext/nnstreamer/tensor_trainer
export PYTHONIOENCODING=utf-8
ifeq ($(DEB_BUILD_ARCH_CPU), arm)
FLOAT16 := -Denable-float16=true
endif
ifeq ($(DEB_BUILD_ARCH_CPU), arm64)
FLOAT16 := -Denable-float16=true
endif

%:
	dh $@ --parallel

override_dh_auto_clean:
	rm -rf ${BUILDDIR}

override_dh_auto_configure:
	mkdir -p ${BUILDDIR}
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
	meson --buildtype=plain --prefix=/usr --sysconfdir=/etc --libdir=lib/$(DEB_HOST_MULTIARCH) --bindir=lib/nnstreamer/bin --includedir=include \
	-Denable-edgetpu=true -Denable-openvino=true -Dgrpc-support=disabled -Dmqtt-support=enabled \
	-Ddatarepo-support=enabled -Donnxruntime-support=enabled \
	-Denable-tizen=false -Denable-test=true -Dinstall-test=true -Dsubplugindir=/usr/lib/nnstreamer $(FLOAT16) ${BUILDDIR}
else
	# Debian has less packages ready.
	meson --buildtype=plain --prefix=/usr --sysconfdir=/etc --libdir=lib/$(DEB_HOST_MULTIARCH) --bindir=lib/nnstreamer/bin --includedir=include \
	-Denable-edgetpu=false -Denable-openvino=false -Dgrpc-support=disabled -Dmqtt-support=enabled \
	-Denable-tizen=false -Denable-test=true -Dinstall-test=true -Dsubplugindir=/usr/lib/nnstreamer ${BUILDDIR}
endif

override_dh_auto_build:
	ninja -C ${BUILDDIR}
	# A few modules are not available in Ubuntu 22.04. Don't try to create them if not available.
	if [ -f './build/ext/nnstreamer/tensor_filter/libnnstreamer_filter_nnfw.so' ]; then echo "NNFW exists" ; else rm debian/nnstreamer-nnfw.install; fi
	if [ -f './build/ext/nnstreamer/tensor_filter/libnnstreamer_filter_pytorch.so' ]; then echo "pytorch exists" ; else rm debian/nnstreamer-pytorch.install; fi
	if [ -f './build/ext/nnstreamer/tensor_filter/libnnstreamer_filter_caffe2.so' ]; then echo "caffe2 exists" ; else rm debian/nnstreamer-caffe2.install; fi

override_dh_auto_test:
	./packaging/run_unittests_binaries.sh ./tests
	LD_LIBRARY_PATH=${NNSTREAMER_BUILD_ROOT_PATH}/tests/nnstreamer_edge ./packaging/run_unittests_binaries.sh ./tests/nnstreamer_edge
	./packaging/run_unittests_binaries.sh ./tests/nnstreamer_datarepo
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
ifeq ($(DEB_HOST_ARCH), amd64)
	if [ -f './tests/tizen_nnfw_runtime/unittest_nnfw_runtime_raw' ]; then ./packaging/run_unittests_binaries.sh ./tests/tizen_nnfw_runtime/unittest_nnfw_runtime_raw; fi
endif
	cd tests && ssat -n -p=1 && cd ..
else
	echo "Skipping SSAT test because it's not in Debian."
endif

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp ninja -C ${BUILDDIR} install

override_dh_install:
	dh_install --sourcedir=debian/tmp --list-missing
# Add --fail-missing option after adding *.install files for all subpackages.


override_dh_clean:
	dh_clean $@
# Prepare SUBSTVARS for Linux distro differences
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
	# Default debian/control targets Xenial.
	# If you want different control for Bionic or later,
	# you may create another control and copy it here.
	cp debian/control.ubuntu.ppa debian/control
else
	cp debian/control.debian debian/control
endif

override_dh_shlibdeps:
	dh_shlibdeps --exclude=libtensorflow2-lite-custom.so
